> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Exchange Refresh Token

> Exchange a refresh token for an access token for a Connected App client.

This endpoint uses your [Custom Domain](/docs/connected-apps/resources/custom-domains).

The `refresh_token` grant type is used to periodically exchange a refresh token for a new access token without user interaction. When using the `refresh_token` grant type, a `refresh_token` must be provided.

This endpoint returns different responses depending on the client being used:

* If a First Party Public or Third Party Public client is used, the original refresh token sent in the request will be [rotated out](https://datatracker.ietf.org/doc/html/rfc6749#section-10.4) and a new `refresh_token` will be present in the response. You must save this new token for next time. Each refresh token has an expiry of 3 months from issuance.
* If a First Party Confidential or Third Party Confidential client is used, no token rotation will occur. The refresh token used in the request will remain valid for future use and no new `refresh_token` will be present in the response. The refresh token has an initial expiry of 3 months, and each use extends its lifetime by another 3 months.

Connected App [**Access Tokens**](/docs/api-reference/consumer/api/connected-apps/tokens/connected-app-access-token-object) are JWTs signed with the project's [JWKS](/docs/api-reference/consumer/api/connected-apps/configuration/get-jwks). Access Tokens expiry is controlled by the client's `access_token_expiry_minutes` field, which defaults to one hour.

You can validate and examine your access and refresh tokens by using the [Token Introspection Endpoint](/docs/api-reference/consumer/api/connected-apps/methods/introspect-token).

Access token JWTs can be validated locally by using a [Stytch Backend SDK](/docs/api-reference/consumer/api/connected-apps/methods/authenticate-access-token-local), or any library that supports the JWT protocol.

<Note>
  Unlike other Stytch API endpoints, this endpoint is not authenticated with a `project_id` and `project_secret` pair. Instead, it is authenticated via the `client_id` and `client_secret` of an active Connected App Client within the current project.
</Note>

This endpoint is an [RFC-6749](https://datatracker.ietf.org/doc/html/rfc6749#section-4.4) compliant token issuing endpoint.

* This endpoint supports passing the `client_id` and `client_secret` within the request body as well as within a [HTTP-Basic Auth](https://datatracker.ietf.org/doc/html/rfc6749#section-2.3.1) header.
* This endpoint supports both `application/json` and `application/x-www-form-urlencoded` content types.

<Info>
  We recommend using the [Custom Domain](/docs/connected-apps/resources/custom-domains) whenever possible. For backwards compatibility reasons, this endpoint is also available at `https://test.stytch.com/v1/public/${projectId}/oauth2/token`.
</Info>

## Body

<ParamField body="client_id" type="string" required>
  The ID of the Connected App client.
</ParamField>

<ParamField body="client_secret" type="string" required>
  The secret of the Connected App client. **Required for confidential clients**
</ParamField>

<ParamField body="grant_type" type="string" required>
  The OAuth2 defined grant type that should be used to acquire an access token. Either `authorization_code` or `refresh_token` is supported for Connected App clients. An error will be returned if this parameter is omitted.
</ParamField>

<ParamField body="refresh_token" type="string" required>
  A refresh token previously issued to the client. This field is required when using the `refresh_token` grant.
</ParamField>

## Response

<ResponseField name="access_token" type="string">
  The access token granted to the client. Access tokens are JWTs signed with the project's JWKS.
</ResponseField>

<ResponseField name="refresh_token" type="string">
  An opaque token that may be used in the future to retrieve a new access token. Only returned if the `offline_access` scope is granted.
</ResponseField>

<ResponseField name="token_type" type="string">
  The type of the returned access token. Today, this value will always be equal to "bearer"
</ResponseField>

<ResponseField name="expires_in" type="number">
  The lifetime in seconds of the access token. For example, the value 3600 denotes that the access token will expire in one hour from the time the response was generated.
</ResponseField>

<RequestIdResponseField />

<StatusCodeResponseField />

<Panel>
  <RequestExample>
    ```curl theme={null}
    curl --request POST \
      --url https://${projectDomain}/v1/oauth2/token \
      -H 'Content-Type: application/json' \
      -d '{
        "client_id": "connected-app-test-d731954d-dab3-4a2b-bdee-07f3ad1be888",
        "client_secret": "NHQhc7ZqsXJVtgmN2MXr1etqsQrGAwJ-iBWNLKY7DzJq",
        "grant_type": "refresh_token",
        "refresh_token": "PvC5UudZ7TPZbELt95yXAQ-8MeEUCRob8bUQ-g52fIJs"
      }'

    ```
  </RequestExample>

  <ResponseExample>
    ```json 200 theme={null}
    {
      "access_token": "eyJ...",
      "expires_in": 3600,
      "refresh_token": "wUU...",
      "scope": "openid email profile phone",
      "token_type": "bearer",
      "id_token": "eyJ...",
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "status_code": 200
    }
    ```

    ```json 404 theme={null}
    {
      "status_code": 404,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "idp_client_not_found",
      "error_message": "The IDP client requested could not be found.",
      "error_url": "https://stytch.com/docs/api/errors/404"
    }
    ```

    ```json 429 theme={null}
    {
      "status_code": 429,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "too_many_requests",
      "error_message": "Too many requests have been made.",
      "error_url": "https://stytch.com/docs/api/errors/429"
    }
    ```

    ```json 500 theme={null}
    {
      "status_code": 500,
      "request_id": "request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141",
      "error_type": "internal_server_error",
      "error_message": "Oops, something seems to have gone wrong, please reach out to support@stytch.com to let us know what went wrong.",
      "error_url": "https://stytch.com/docs/api/errors/500"
    }
    ```
  </ResponseExample>
</Panel>
